clear;

h = 0.001;
T = 2;
u1= 1/4;
u2= 1/2;
%---------
k = 0.001;
x = -1:h:1;
Nx = length(x);
t = floor(T/k);
U(1,1:length([-1:h:0-h])) = u1;
U(1,(Nx+1)/2+1:Nx) = u2;
U(1,(Nx+1)/2) = (u2+u1)/2;


for i = 1:t
   U(i,1) = U(i,2);
   U(i,Nx) = U(i,Nx-1);
    
   for n = 2:Nx-1
      U(i+1,n) = .5*(U(i,n+1)+U(i,n-1))-(k/(2*h))*((U(i,n+1)-U(i,n+1)^2)-(U(i,n-1)-U(i,n-1)^2)); 
   end
    
    
end
%---Rarefacion u1 = 3/4, u2 = 1/4
%n1 = [-1:h:-.5*T-h];
%n2 = [-T*.5:h:T*.5];
%n3 = [.5*T+h:h:1];
%n2 = .5*(1-n2/T); % M man dele p T her?
%n1 = ones(1,length(n1))*u1;
%n3 = ones(1,length(n3))*u2;
%G = [n1 n2 n3];
%-------Shock solution u1 = 1/4, u2 = 1/2
s = 1 - u1 - u2;
n1 = [1:round((1+s*T)/h)-1];                    
n2 = [round((1+s*T)/h)+1:Nx];             
n1 = ones(1,length(n1))*u1;
n2 = ones(1,length(n2))*u2;
n3 = .5*(u2 + u1);
G = [n1 n3 n2];


plot(x,G,'k')
hold on
plot(x,U(t,:),'--k')


h= 0.01;
x = -1:h:1;
Nx = length(x);
U2(1,1:length([-1:h:0-h])) = u1;
U2(1,(Nx+1)/2+1:Nx) = u2;
U2(1,(Nx+1)/2) = (u2+u1)/2;


for i = 1:t
   U2(i,1) = U2(i,2);
   U2(i,Nx) = U2(i,Nx-1);
    
   for n = 2:Nx-1
      U2(i+1,n) = .5*(U2(i,n+1)+U2(i,n-1))-(k/(2*h))*((U2(i,n+1)-U2(i,n+1)^2)-(U2(i,n-1)-U2(i,n-1)^2)); 
   end
    
    
end


plot(x,U2(t,:),'--k')
legend('Exact','h = 0.01','h = 0.001')
title('Lax-Friedrichs')
axis([-.5 1 0 .6])
